# Roo Code 3.9.0 Release Notes (2025-03-18)

This release introduces internationalization, remote MCP connectivity via SSE, text-to-speech, and numerous other improvements.

## Feature Highlights

*   **Internationalization:** Roo Code now supports 14 languages: Simplified Chinese, Traditional Chinese, Spanish, Hindi, French, Portuguese, German, Japanese, Korean, Italian, Turkish, Vietnamese, Polish, and Catalan. Change language in Advanced Settings > Language. (thanks feifei325!)
*   **MCP Remote Connectivity (SSE):** Added support for connecting to remote MCP servers using Server-Sent Events (SSE), complementing existing stdio support. (thanks aheizi!)
*   **Text-to-Speech:** Added an option for Roo to provide audio feedback alongside visual responses. Enable in Advanced Settings > Notifications. (thanks heyseth!)
*   **OpenRouter Provider Selection:** Added the ability to choose a specific provider when using OpenRouter models via the "Configure Profile" settings. (thanks PhunkyBob!)
*   **Batch History Deletion:** Added support for selecting and deleting multiple task history items at once via the "VIEW ALL" history screen. (thanks aheizi!)

## Terminal Improvements

*   Made the terminal shell integration timeout configurable (1-60 seconds) via Advanced Settings to resolve issues with long shell startup times. (thanks filthy, kiwina, KJ7LNW!)
*   Fixed a race condition that could cause terminal output to hang or not be recognized. (thanks KJ7LNW!)

## Bug Fixes & General Improvements

*   Improved task deletion when underlying files are missing. (thanks GitlyHallows!)
*   Improved support for NixOS & direnv. (thanks wkordalski!)
*   Exposed task stack in `RooCodeAPI`. (thanks franekp!)
*   Fixed Human Relay to work on the welcome screen and added internationalization support. (thanks NyxJae!)
*   Fixed display updating for Bedrock custom ARNs that are prompt routers. (thanks Smartsheet-JB-Brown!)
*   Fixed exclusion of search highlighting when copying items from task history. (thanks im47cn!)
*   Fixed context mentions to work with multiple-workspace projects. (thanks teddyOOXX!)
*   Fixed task history saving when running multiple Roo instances. (thanks samhvw8!)
*   Fixed wheel scrolling when Roo is opened in editor tabs. (thanks GitlyHallows!)
*   Fixed file mentions when using the "Add to context" code action. (thanks qdaxb!)
*   Gave models visibility into the current task's API cost.